;; verschiedene wandler fuer die iso-, ascii-, ibm-welt
;; januar 1993, JS

(defun wandler-definitionen ()
  (interactive)
  (setq iso-ae "")
  (setq iso-oe "")
  (setq iso-ue "")
  (setq iso-AE "")
  (setq iso-OE "")
  (setq iso-UE "")
  (setq iso-ss "")
 
  (setq ibm-ae "")
  (setq ibm-oe "")
  (setq ibm-ue "")
  (setq ibm-AE "")
  (setq ibm-OE "")
  (setq ibm-UE "")
  (setq ibm-ss "")

  (setq dach-ae "a^")
  (setq dach-oe "o^")
  (setq dach-ue "u^")
  (setq dach-AE "A^")
  (setq dach-OE "O^")
  (setq dach-UE "U^")
  (setq dach-ss "s^"))

(defun replace-in-whole-buffer (from-string to-string)
  "Ersetzen einer Zeichenkombination im aktuellen Buffer"
  (interactive "sFrom: \nsFrom %s To: ")
  (let ((case-fold-search nil)
	(case-replace t))
    (goto-char (point-min))
    (while (search-forward from-string nil t)
      (replace-match to-string t t))))

(defun dach_to_ibm ()
  "umlaut-repraesentation von a^ -> IBM"
  (interactive)
  (wandler-definitionen)
  (replace-in-whole-buffer dach-ae ibm-ae)
  (replace-in-whole-buffer dach-oe ibm-oe)
  (replace-in-whole-buffer dach-ue ibm-ue)
  (replace-in-whole-buffer dach-AE ibm-AE)
  (replace-in-whole-buffer dach-OE ibm-OE)
  (replace-in-whole-buffer dach-UE ibm-UE)
  (replace-in-whole-buffer dach-ss ibm-ss))


(defun ibm_to_dach ()
  "IBM-Umlaute zu a^ etc."
  (interactive)
  (wandler-definitionen)
  (replace-in-whole-buffer ibm-ae dach-ae)
  (replace-in-whole-buffer ibm-oe dach-oe)
  (replace-in-whole-buffer ibm-ue dach-ue)
  (replace-in-whole-buffer ibm-AE dach-AE)
  (replace-in-whole-buffer ibm-OE dach-OE)
  (replace-in-whole-buffer ibm-UE dach-UE)
  (replace-in-whole-buffer ibm-ss dach-ss))

(defun dach_to_iso ()
  "umlaut-repraesentation von a^ -> iso"
  (interactive)
  (wandler-definitionen)
  (replace-in-whole-buffer dach-ae iso-ae)
  (replace-in-whole-buffer dach-oe iso-oe)
  (replace-in-whole-buffer dach-ue iso-ue)
  (replace-in-whole-buffer dach-AE iso-AE)
  (replace-in-whole-buffer dach-OE iso-OE)
  (replace-in-whole-buffer dach-UE iso-UE)
  (replace-in-whole-buffer dach-ss iso-ss))

(defun iso_to_dach ()
  "ISO-Umlaute zu a^ etc."
  (interactive)
  (wandler-definitionen)
  (replace-in-whole-buffer iso-ae dach-ae)
  (replace-in-whole-buffer iso-oe dach-oe)
  (replace-in-whole-buffer iso-ue dach-ue)
  (replace-in-whole-buffer iso-AE dach-AE)
  (replace-in-whole-buffer iso-OE dach-OE)
  (replace-in-whole-buffer iso-UE dach-UE)
  (replace-in-whole-buffer iso-ss dach-ss))

(defun dach_to_ae ()
  "Umlaute a^ -> ae ..."
  (interactive)
  (let ((case-replace t)
	(case-fold-search nil))
    (goto-char (point-min))
    (replace-regexp "\\([aAoOuU]\\)^" "\\1e" nil)
    (goto-char (point-min))
    (replace-string "s^" "ss")))

(defun ae_to_dach ()
  (interactive)
  (let ((case-fold-search nil)
	(case-replace t)
	(from "")
	(to "")
	(offset 0)
	(erledigt '())
	(liste '(
		 ("[ae]ue" "\\&" 0)
		 ("Michael" "\\&" 1)
		 ("[qQ]ue" "\\&" 0)
		 ("uei" "\\&" 1)
		 ("[zZ]uer" "\\&" 1)
		 ("[dtns]uell" "\\&" 2)
		 ("[Vv]alue" "\\&" 0)
		 ("tinue" "\\&" 0)
		 ("\\([Aa]\\)eusser" "\\1^us^er" 0)
		 ("laessi" "la^ssi" 1)
		 ("\\([ao]\\)ess\\([^c]\\)" "\\1^s^\\2" 1)
		 ("\\([mwMW]\\)uesst" "\\1u^s^t" 0)
		 ("\\([aouAOU]\\)e" "\\1^" 0)
		 ("passwd" "\\&" 2)
		 ("password" "\\&" 4)
		 ("\\([mMdDpPfF]\\)\\([ai]\\)ss\\([^ieua]\\)" "\\1\\2s^\\3" 1)
		 ("iess" "ies^" 0)
		 ("eiss" "eis^"0 )
		 ("\\([Aa]\\)usse\\([nr]\\)" "\\1us^e\\2" 1)
		 ("\\([^Aa]\\)uss\\([^eiu]\\)" "\\1us^\\2" 1)
		 ("\\([Gg]\\)ross\\([^c]\\)" "\\1ros^\\2" 1)
		 ("zess\\([^e]\\)" "zes^\\1" 1)
		 )))
    (message "%s" "Augenblick, bitte ...")
    (while (car liste)
      (goto-char (point-min))
      (setq from (eval (car (car liste))))
      (setq to (eval (car (cdr (car liste)))))
      (setq offset (car (cdr (cdr (car liste)))))
      (while (re-search-forward from (point-max) t)
	(if (not (memq (point) erledigt))
	    (progn
	      (setq erledigt (cons (- (point) offset ) erledigt))
	      (replace-match to))))
      (setq liste (cdr liste)))
    (message "%s" "Wandlung fertig!")))


(defun ae_to_iso ()
  "Umlaute ae -> iso"
  (interactive)
  (ae_to_dach)
  (dach_to_iso))

(defun ae_to_ibm ()
  "Umlaute ae -> ibm"
  (interactive)
  (ae_to_dach)
  (dach_to_ibm))

(defun iso_to_ae ()
  "Umlaute iso -> ae"
  (interactive)
  (iso_to_dach)
  (dach_to_ae))

(defun ibm_to_ae ()
  "Umlaute ibm -> ae"
  (interactive)
  (ibm_to_dach)
  (dach_to_ae))


(defun ibm_to_iso ()
  "Umlaute iso -> ibm"
  (interactive)
  (ibm_to_dach)
  (dach_to_iso))


(defun iso_to_ibm ()
  "umlaut-repraesentationen ISO -> IBM"
  (interactive)
  (iso_to_dach)
  (dach_to_ibm))


(defun to_dt ()
  "aus gewohnheit, statt dach_to_ibm"
  (interactive)
  (iso_to_ibm)
  (dach_to_ibm))

(defun to_ibm ()
  (interactive)
  (to_dt))
